/*
 * $Id: kernel_uii.c,v 1.4 1999/04/27 01:13:56 masaki Exp $
 */

#include <mrt.h>
#include <interface.h>

/* show_interfaces
 * Dump various interface stats/info to a socket
 */
int
show_interfaces (uii_connection_t * uii)
{
    interface_t *interfce;
    ll_addr_t *ll_addr;
    char tmpx[MAXLINE];

    if (INTERFACE_MASTER == NULL) return (0);

    LL_Iterate (INTERFACE_MASTER->ll_interfaces, interfce) {
	uii_add_bulk_output (uii, "Interface %s %s mtu %d\n",
		       interfce->name,
		       print_iflags (tmpx, MAXLINE, interfce->flags),
		       interfce->mtu);

#ifdef notdef
	if (interfce->prefix != NULL) {
	    uii_add_bulk_output (uii, "  inet4 %s\n", 
				 prefix_toa (interfce->prefix));
	}
#ifdef HAVE_IPV6
	if (interfce->prefix6 != NULL) {
	    uii_add_bulk_output (uii, "  inet6 %s\n", 
				 prefix_toa (interfce->prefix6));
	}
#endif /* HAVE_IPV6 */
#endif
	LL_Iterate (interfce->ll_addr, ll_addr) {
	    assert (ll_addr->prefix);

	    tmpx[0] = '\0';
#define IFF_POINTOPOINT 4

	    if (ll_addr->broadcast)
		sprintf (tmpx, " %s %s", 
			BIT_TEST (interfce->flags, IFF_POINTOPOINT) ?
		      "-->" : "broadcast", prefix_toa (ll_addr->broadcast));

	    uii_add_bulk_output (uii, "  %s %s/%d%s\n",
			   (ll_addr->prefix->family == AF_INET) ? "inet" :
#ifdef HAVE_IPV6
			   (ll_addr->prefix->family == AF_INET6) ? "inet6" :
#endif /* HAVE_IPV6 */
			   "???",
		prefix_toa (ll_addr->prefix), ll_addr->prefix->bitlen, tmpx);
	}
	uii_add_bulk_output (uii, "\n");
    }
    return (1);
}


